#include <stdio.h>		//printf()
#include <stdlib.h>		//exit()
#include <signal.h>     //signal()

#include "DEV_Config.h"
#include <time.h>
#include "AW9523B.h"


void  Handler(int signo)
{
    //System Exit
    printf("\r\nHandler:exit\r\n");
    DEV_ModuleExit();

    exit(0);
}

int main(void)
{
    // Exception handling:ctrl + c
    signal(SIGINT, Handler);
    DEV_ModuleInit();

    if(AW9523B_Init() != 0) {
        printf("init err!!!\r\n");
        return 0;
    }
    //ouput
    PortMode(0, 0);
    // PortOutput(0, 0xf0);
    // PortMode(1, 0);
    // PortOutput(1, 0xff);
    // PortInput(1);

    //input
    PortMode(1, 1);
    UBYTE tm = 1;
    UBYTE readpin;
    
    while(1) {
        tm = 1;
        for(UBYTE x =0; x<8; x++) {
            PortOutput(0, 1<<x);
            if(ReadIntPin() == 0) {
                while(ReadIntPin() != 0) {
                    // Serial.println();
                    printf("int\r\n");
                }
                printf("int pin %d\r\n", ReadIntPin());
                readpin =  PortInput(1);
                printf("interrupted:read is change, time:%d\r\n", tm);
                printf("output: pin%d = %d\r\n", x, 1<<x);
                printf("input : pin%d = %d\r\n", x, readpin);
                
                // printf();
            }
            tm = tm + 1;
            DEV_Delay_ms(2000);
        }
    }
    //System Exit
    DEV_ModuleExit();
    return 0;

}

